
sntp.sync()

local tz = 3 -- Time zone
local key = "key" -- Openweathermap key
local city = "Moscow" -- 

if not key or key == 'key' then return end

local request = "GET http://api.openweathermap.org/data/2.5/forecast?q="..city.."&mode=xml&units=metric&cnt=9&appid="..key.." HTTP/1.1\r\n" ..
"Host: api.openweathermap.org\r\n"

local tm = rtctime.epoch2cal(rtctime.get())
local hour = tm["hour"] + tz
print('\t\t\thour now:', hour) 

if not wth then wth = {} end

local _conn
local _skip_headers = true
local _chunk = ""

local function stop_stream(cb)
  if _conn then
    _conn:close()
    _conn = nil
  end
  if cb then cb()  end 
end


local function start_play()
  print("starting playback")
end
local frame = "T15"
if hour > 15 then frame = "T03" end

local gotcode = false

local function data_received(c, data)
  if _skip_headers then
    _chunk = _chunk..data
    local i, j = string.find(_chunk, frame)
    if i then
      _skip_headers = false
      data = string.sub(_chunk, j+1, -1)
      _chunk = data
    else
      _chunk = ""
    end
  end

  if not _skip_headers then
    if gotcode then _chunk = _chunk..data end
    local code = string.match(_chunk, ':00"><symbol number="(%d+)' )
    local tempavg = string.match(_chunk, 's" value="(%p*%d+\.%d*)' )
    local sky = string.match(data, 'value="(%a+%s*%a*)' )
    if code and tempavg then
      print('\n\t\t\tGot Data to '..frame..':00')
      print('\t\t\tGot Code:', code, tempavg)
      print('\t\t\tSky:', sky)
      wth.codef = code
      wth.maintemp = tempavg
      stop_stream()
    else
        gotcode = true
    end
  end
end

local function cb_disconnected()
  print("Disconnected")
end

_conn = net.createConnection(net.TCP, 0)
_conn:on("connection", function(conn, payload) conn:send(request.."Connection: close\r\nAccept: /\r\n\r\n") end)
_conn:on("receive", data_received)
_conn:on("disconnection", cb_disconnected)
_conn:connect(80, 'api.openweathermap.org')
