local key = "key" -- Openweathermap key 
local city = "Moscow"
print('city:'..city)

if not key or key == 'key' then return end

if m then m:close(); m = nil; dat.broker= false end
if not dat then dat = {} end
if not wth then wth = {} end

local conn, killask

local _skip_hd = true
local _chk = ''
local tempnow

local request = "GET http://api.openweathermap.org/data/2.5/weather?q="..city.."&mode=xml&units=metric&appid="..key.." HTTP/1.1\r\n" ..
"Host: api.openweathermap.org\r\n"


local function cb_disconnected(c)
    
    local status, err = pcall(function() conn:close() end)
    print('status, err', status, err)
    c, conn = nil, nil
    print('disconnected')
    if not tempnow then
        print('Lost answer!')
    end
    if file.exists('mqttset.lua') then dofile'mqttset.lua' end
end

local function data_received(c, data)
    if killask then killask:stop(); killask:unregister(); killask = nil end

    if _skip_hd then
        _chk = _chk..data
        local i, j = string.find(_chk, '?>')
        if i then
            _skip_hd = false
            data = string.sub(_chk, j + 1, -1)
            _chk = nil
        end
    end

    if not _skip_hd then
        tempnow = string.match(data, 'temperature value="(%p*%d+.?%d?%d?)' )
        local tempmin = string.match(data, 'min="(%p*%d+.?%d?%d?)' )
        local tempmax = string.match(data, 'max="(%p*%d+.?%d?%d?)' )
        local code = string.match(data, 'clouds value="(%d+)' )
        local sky = string.match(data, 'value="(%a+%s*%a*)' )

        print('tempmow:', tempnow)
        print('tempmin:', tempmin)
        print('tempmax:', tempmax)
        print('code:', code)
        print('sky:', sky)
        wth.tserver = tempnow
        wth.codenow = code
        wth.minnow = tempmin
        wth.maxnow = tempmax
        cb_disconnected(c)
    end
end


if wifi.sta.status() == 5 then
    net.dns.resolve("api.openweathermap.org", function(sk, ip)
        if (ip == nil) then
            print("Lost DNS openweathermap!")
        else
            killask = tmr.create()
            killask:alarm(10000, 0, function(_)
                if conn then
                    cb_disconnected()
                    print('\n\nConn killed!\n\n')
                end
            end)
            
            conn = net.createConnection(net.TCP, 0)
            conn:on("connection", function(conn, payload) conn:send(request.."Connection: close\r\nAccept: /\r\n\r\n") end)
            conn:on("disconnection", cb_disconnected)
            conn:on("receive", data_received)
            conn:connect(80, 'api.openweathermap.org')
        end
    end)
end